:root {
    --data-color: #6EDBDf;
    --data-color-emphasis: #7bDCA5;
    --text-white: #FFFFFF;
    --bar-height: 50px;
    --bar-color: rgb(48,48,48); /*Home*/
    --bar-color2: rgb(35, 135, 212); /*IoT*/
    --background-color: rgb(100,191,185);
    --background-dark-color: rgb(80,151,145);
    --background-color2: #303030;
    --link-color: rgb(111,111,111);
    --block-color: rgb(91, 91, 91);
}

html {
    height: 100vh;
}

body {
    font-family: NanumGothic;
    width: 100%;
    height: 100vh;
}

#home {
    margin: 0;
    display: flex;
    flex-direction: column;
    height: 100vh;
    background-color: var(--background-color);
    overflow: hidden;
}

article#IoT {
    margin: 0;
    display: flex;
    flex-direction: column;
    height: 100vh;
    background-color: var(--background-color);
    overflow: hidden;
}


.no-selection {
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
}


/*************Home pages css****************/
#home .content {
    flex-grow: 1;
    padding: 20px;
    overflow: auto;
}
    #home .content.fixed {
        overflow: hidden;
    }
#home .container {
    width: 60%;
    margin: auto;
    padding: 40px 40px;

    font-size: 17px;

    background-color: #fff;
    border-radius: 30px;
    box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
    box-sizing: border-box;

    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
}
#home form, #home .form {
    width: 90%;
    height: 100%;
    display: flex;
    justify-content: space-evenly;
    flex-direction: column;
}

#home .input-field {
    width: 100%;
    display: flex;
    flex-direction: column;
    margin-bottom: 20px;
}

    #home .input-field label {
        margin-bottom: .5rem;
    }
    #home .input-field span.oi>label {
        margin-left: 5px;
    }
#home .checkbox {
    accent-color: var(--background-color);
    background-color: var(--background-color);
    border-color: var(--background-color);
    margin-top: 0.25rem;
}

#home .link {
    color: var(--link-color);
    text-decoration: underline;
}


#home .container button {
    padding: 10px 20px;
    width: 100%;
    font-size: 19px;
    /*letter-spacing : 0.5em;
            word-spacing: 0.4em;*/
    border: 16px;
    background-color: var(--background-color);
    border-radius: .3rem;
}
    #home .container button.small {
        padding: 7px 20px;
        font-size: 18px;
    }
#home .container button.secondary {
    background-color: #b5b5b5;
}
    #home .container button:hover {
        background-color: rgb(120,201,195);
    }
    #home .container button:active {
        background-color: var(--background-dark-color);
    }

    #home .container button.secondary:hover {
        background-color: #a5a5a5;
    }
    #home .container button.secondary:active {
        background-color: #858585;
    }


@media (max-width: 600px) {
    #home .content {
        align-items: flex-start;
    }
    #home .container {
        width: 100%;
        margin: 0 auto;
        box-shadow: none;
    }
}

.content {
    flex-grow: 1;
    display: flex;
    justify-content: center;
    align-items: center;
}

.content-center {
    display: flex;
    justify-content: center;
    align-items: center;
}

footer {
    background-color: rgb(35, 135, 212);
    
}

.btn:focus {
    box-shadow: none;
}

/*button > label{
    cursor:inherit;
}*/

.cursor-loading{
    cursor:wait;
}

#NavBarBg {
    background-color: rgb(35, 135, 212);
    position: sticky;
    width: 100%;
    height: 60px;
    padding-top: 10px;
}

#NavBarAg {
    display: flex;
    justify-content: space-between;
}

#mainPage {
    position: sticky;
    display: flex;
    background-color: #303030;
    flex-wrap: wrap;
    width: 100%;
    padding: 9px 0 0 9px;
    height: 100%;
    overflow: auto;
}
#mainPage.fixed{
    overflow: hidden;
}


#webIotTitle {
    float: left;
    margin-left: 34px;
    margin-top: 5px;
    color: rgb(255, 255, 255);
    user-select: none
}


div.titleButton {
    float: right;
    position: relative;
    margin-right: 20px;
}

label.titleButton {
    margin-top: 3px;
    margin-bottom: 3px;
}

.title-text {
    margin: 0px;
    padding: 0px;
}

.text-bold {
    font-weight: bold;
}

/************ScrollBar***********/
div::-webkit-scrollbar{
    width:10px;
}

#home div::-webkit-scrollbar-thumb {
    background-color: rgba(48,48,48,0.5);
    /* border: 5px solid var(--background-color2); */
    border-right: 5px solid var(--background-color);
}

#home div.scrollbar-on-block::-webkit-scrollbar-thumb {
    border-right: 0px;
}
    #home div::-webkit-scrollbar-thumb:hover {
        background-color: rgba(48,48,48,1);
    }

#IoT div::-webkit-scrollbar-thumb {
    background-color: rgba(91,91,91,0.5);
    /* border: 5px solid var(--background-color2); */
    border-right: 5px solid var(--background-color2);
}

#IoT div.scrollbar-bright::-webkit-scrollbar-thumb {
    background-color: rgb(111,111,111);
    border-right: 0px solid var(--background-color2);
}
    #IoT div.scrollbar-bright::-webkit-scrollbar-thumb:hover {
        background-color: rgb(131,131,131);
    }
#IoT div::-webkit-scrollbar-thumb:hover {
    background-color: rgba(91,91,91,1);
}


div::-webkit-scrollbar-track {
    display: none;
}

div:not(.inside)::-webkit-scrollbar-button:vertical:start:increment,
div::-webkit-scrollbar-button:vertical:end:decrement {
    display: block;
    height: 9px;
}
/****************Block********************/
.block:not(.menuBlock) {
    background-color: rgb(91, 91, 91);
    float: left;
    margin: 0px 9px 9px 0;
    position: relative;
}
    .block:has(p.err) {
        justify-content: center;
        align-items: center;
        display:flex;
        flex-direction:row;
        height: auto !important;
       /* width: auto !important;*/
        max-width: 100vw !important;
        min-height: 0 !important;
    }
    .block p.err{
        margin: 0px;
    }

    .block[optional]{
        display:none !important;
    }

    .timeBlock {
        padding: 20px 20px;
        color: var(--text-white);
        font-weight: bold;
    }

.loginBlock {
    background-color: white;
    padding: 20px 20px;
    color: black;
}

/****************Generator Block********************/

.GenBlock {
    flex: 3 3 810px;
  /*  width: 100%;
    min-width: 200px;
    max-width: 800px;
    height: 100%;*/
    min-height: 100px;
   /* max-height: 500px;*/
    padding: 20px 20px;
}

.GenBlockRow {
    display: flex;
}


.GenDataSet {
    flex: 1;
    display: flex;
    justify-content: space-around;
}

.Invisible {
    background-color: inherit;
}

.GenDataSplitter {
    margin: 0px 10px;
    width: 1px;
}

    .GenDataSplitter:not(.Invisible) {
        background-color: #D4D4D4;
    }

.GenRowSplitter {
    margin: 10px 0px;
    height: 1px;
}

    .GenRowSplitter:not(.Invisible) {
        background-color: #D4D4D4;
    }


.genTextName {
    flex: 2;
    color: var(--text-white);
    margin-bottom: auto;
    font-size: 15px;
    font-weight: normal;
    white-space: nowrap;
}

.genTextValue {
    flex: 3;
    font-size: 25px;
    margin: auto 0;
    text-align: right;
    color: var(--data-color);
    font-weight: normal;
    white-space: nowrap;
}

.genTextUnit {
    flex: 1;
    color: white;
    margin-top: auto;
    font-size: 15px;
    font-weight: normal;
    margin-left: 4pt;
    white-space: nowrap;
}


    .genTextName[important] {
    font-size: 17px;
    font-weight: normal;
}

    .genTextValue[important] {
    font-size: 30px;
    color: var(--data-color-emphasis);
    font-weight: bold;
}

    .getTextUnit[important] {
    font-size: 20px;
    font-weight: bold;
}


/****************LED Block********************/

.LedBlock {
    flex: 1 1 270px;
   /* width: 100%;
    min-width: 100px;
    max-width: 200px;
    height: 100%;*/
    min-height: 400px;
   /* max-height: 600px;*/
    padding: 20px 20px;
    display: flex;
    flex-direction: column;
}



.LedRow {
    flex: 1;
    display: flex;
    justify-content: space-between;
}

.LedRowSplitter {
    margin: 10px 0px;
    height: 1px;
}

    .LedRowSplitter:not(.Invisible) {
        background-color: #D4D4D4;
    }

.LedText {
    flex: 1;
    color: var(--text-white);
    font-size: 20px;
    font-weight: normal;
    white-space: nowrap;
}

    .LedText.LedTitle {
        font-size: 30px;
        margin-bottom: 10px;
    }

.LedOn::before {
    content: "\25CF"" " /* ¡Ü */;
    text-align: right;
    color: var(--data-color);
}

.LedOff::before {
    content: "\25CB"" "/* ¡Û */;
    text-align: right;
}

/****************Digital Block********************/

.DigitalBlock {
    flex: 1 1 270px;
    /*width: 100%;
    min-width: 210px;
    max-width: 240px;
    height: 100%;*/
    min-height: 400px;
  /*  max-height: 600px;*/
    padding: 20px 20px;
    display: flex;
    flex-direction: column;
}

.DigitalText {
    flex: 1;
    color: var(--text-white);
    font-size: 20px;
    font-weight: normal;

    white-space: nowrap;
}
    .DigitalText.title {
        font-size: 30px;
    }

.DigitalText.NotUse{
    color: #303030;
}

.PortOn::before {
    /*content: "\25FC"" "*/ /* ¡á */ /*;*/
    content: "\25CF"" " /* ¡Ü */;
    text-align: right;
    color: var(--data-color);
}
/*.PortOn.No::before {
    content: "\25B2"" "*/ /* ¡ã *//*;
    font-weight: 900;
    text-align: right;
    color: var(--data-color);
}
.PortOn.Nc::before {
    content: "\25BC"" "*/ /* ¡å *//*;
    text-align: right;
    color: var(--data-color);
}*/

.PortOff::before {
    /*content: "\25FB"" "*/ /* ¡à */ /*;*/
    content: "\25CB"" " /* ¡Û */;
    text-align: right;
}
/*.PortOff.No::before {
    content: "\25B3"" "*/ /* ¡â *//*;
    text-align: right;
}

.PortOff.Nc::before {
    content: "\25BD"" "*/ /* ¡ä *//*;
    font-weight:100;

    text-align: right;
}*/




/*****************Menu**********************/
.menuBlock {
    display: flex;
    width: 100%;
    height: 100%;
}

.mainMenu {
    flex: 0 0 200px;
    overflow:auto;
}
.mainToggler{
    display:none;
}

    .mainMenu .mainItem {
        background-color: rgb(71, 71, 71);
        color: white;
        margin: 0 9px 9px 0;
        padding: 10px;
        cursor: pointer;
        display: block;
        text-decoration: none;
    }

        .mainMenu .mainItem[selected] {
            background-color: rgb(111, 111, 111);
            color: white;
           /* margin-right: 0px;*/
        }

        .mainMenu .mainItem:hover {
            background-color: rgb(91, 91, 91);
        }

.subCollection {
    overflow: auto;
    width: 100%;
}

.subMenu {
   /* flex: 1;*/
    /*margin: 0 9px 9px 0;*/
    /* margin-bottom: 9px;*/
    /*overflow: auto;*/
    display: flex;
    flex-wrap: wrap;
}

    .subMenu .subChunk {
        /* display:flex;*/
        margin: 0 9px 9px 0;
        background-color: rgb(111, 111, 111);
        padding: 5px 0 0 5px;
        color: white;
    }

    .subMenu .subName {
        padding: 6px 0 6px 6px;
        font-size: 18px;
    }

    .subMenu .subValues {
        /*display:flex;*/
        font-size: 20px;
    }

    .subMenu .subItem {
        background-color: rgb(91, 91, 91);
        margin: 0 5px 5px 0;
        display: flex;
        padding: 5px;
        min-width: 300px;
        justify-content: space-between;
    }

.subItem .name {
    margin-right: 5px;
    flex: 3;
    white-space: nowrap;
}

.subItem .value {
    margin-right: 5px;
    color: var(--data-color);
    flex: 2;
    text-align: end;
    white-space: nowrap;
}

.subItem .unit {
    font-size: 16px;
    align-self: end;
}
/****************Loading********************/


.lds-ring {
    display: inline-block;
    
    width: 80px;
    height: 80px;
    position: absolute;
    top: 50%;
    left: 50%;
    margin: -40px 0 0 -40px;
}

    .lds-ring div {
        box-sizing: border-box;
        display: block;
        position: absolute;
        width: 64px;
        height: 64px;
        margin: 8px;
        border: 8px solid #fff;
        border-radius: 50%;
        animation: lds-ring 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;
        border-color: #fff transparent transparent transparent;
    }

        .lds-ring div:nth-child(1) {
            animation-delay: -0.45s;
        }

        .lds-ring div:nth-child(2) {
            animation-delay: -0.3s;
        }

        .lds-ring div:nth-child(3) {
            animation-delay: -0.15s;
        }

@keyframes lds-ring {
    0% {
        transform: rotate(0deg);
    }

    100% {
        transform: rotate(360deg);
    }
}

/****************Alarm Modal***************/
.modal {
    width: 100%;
    height: calc(100vh - 2 * var(--bar-height));
    position: fixed;
    left: 0;
    top: var(--bar-height);
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    z-index:initial;
}

    .modal.fullscreen{
        top:0;
        height:100%;
    }

.modal.modal-overlay {
    
    
    background: rgba(255, 255, 255, 0.25);
   /* box-shadow: 0 8px 32px 0 rgba(31, 38, 135, 0.37);*/
    backdrop-filter: blur(1.5px);
    -webkit-backdrop-filter: blur(1.5px);
    border-radius: 10px;
    border: 1px solid rgba(255, 255, 255, 0.18);
}

    .modal .modal-window {
        background: var(--bar-color2);
        box-shadow: 0 8px 32px 0 rgba( 31, 38, 135, 0.37 );
        backdrop-filter: blur( 13.5px );
        -webkit-backdrop-filter: blur( 13.5px );
        border-radius: 10px;
        border: 1px solid rgba( 255, 255, 255, 0.18 );
        width: min(400px,96vw);
        height: min(500px,70vh);
        position: relative;
        /*top: -100px;*/
        padding: 10px;
    }

    .modal .modal-window-dark {
        background: var(--background-color2);
        box-shadow: 0 8px 32px 0 rgba( 31, 38, 135, 0.37 );
        backdrop-filter: blur( 13.5px );
        -webkit-backdrop-filter: blur( 13.5px );
        border-radius: 10px;
        border: 1px solid rgba( 255, 255, 255, 0.18 );
        width: min(400px,96vw);
        height: min(600px,83vh);
        position: relative;
        /*top: -100px;*/
        padding: 10px;
    }

.modal .title {
    padding-left: 10px;
    display: inline;
    text-shadow: 1px 1px 2px gray;
    color: white;
}

    .modal .title h2 {
        display: inline;
    }

    .modal .close-area {
        display: inline;
        float: right;
        padding-right: 10px;
        cursor: pointer;
        text-shadow: 1px 1px 2px gray;
        color: white;
        font-size: larger;
    }
        .modal .close-area:hover {
            color: lightgray
        }
        .modal .close-area:active {
            color:#b9b9b9;
        }

    .modal .content {
        display: block;
        background-color: white;
        margin-top: 20px;
        padding: 20px 17px 0;
        font-size: 1.1rem;
        /*text-shadow: 1px 1px 2px gray;*/
        font-weight: bold;
        color: rgb( 35, 135, 212);
        border-radius: 4px;
        height: min(88%,calc(70vh - 74px));
        overflow: auto;
    }

    .modal .content-dark {
        background-color:inherit;
        color: var(--text-white);
        height: min(90%,calc(83vh - 74px));
    }

    .modal .content-flex{
        display: flex;
        /*justify-content:space-between;*/
        justify-content:flex-start;
        flex-direction:column;
        /*align-content:center;*/
       /* flex-wrap:wrap;*/
    }

    .modal .content .item {
        margin-bottom: 11px;
    }

        .modal .content .item::before {
            content: "\25CF"" " /* ¡Ü */;
        }
    .modal .itemRow {
        display: flex;
        justify-content: space-evenly;
        flex-direction: row;
        /*align-content:center;*/
        flex-wrap: nowrap;
    }
    .modal .content .cmdItem {
        width: 90px;
        height: 110px;
        color: var(--text-white);
        margin: 0 10px 10px 0;
        background-color: var(--block-color);
        display: flex;
        flex-direction: column-reverse;
        justify-content: space-between;
        align-items: center;
        padding: 13px 0 4px;
        border-radius: 10px;
        -webkit-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none
    }
    .modal .content .cmdItem:hover {
       
        background-color: #3c3c3c;
        /*color: var(--text-white);*/
    }
        .modal:not([disable]) .content .cmdItem:active {
            color: orange;
            background-color: var(--block-color);

            margin: 3px 13px 10px 3px;
            width: 84px;
            height: 104px;
            /*background-color: #909090;*/
        }
            .modal:not([disable]) .content .cmdItem:active img {
                /*  opacity:0.5;*/
                /*margin-top:2.5px;*/
                height: 55px;
            }

.cmdpw{
    display:flex;
    flex-direction: column;
    justify-content:stretch;
}
    .cmdpw > * {
        margin-bottom:20px;

    }

    .cmdpw input {
        border-radius: 7px;
        padding-left: 7px;
        height:2em;
        background-color: var(--block-color);
        color:var(--text-white);
    }



.cursor-pointer{
    cursor: pointer;
}

@media (max-width:600px) {
    .GenBlockRow {
        display: flex;
        flex-direction: column;
    }

    .mobileInvisible{
        display:none;
    }
    .mainToggler {
        cursor: pointer;
        display: inline-block;
        float: right;
        margin: 0 5px 0px 0;
        font-size: 20px;
        transform: translateY(-2px);
    }
    .mainMenu {
        flex: initial;
        overflow: inherit;
    }
        .mainMenu .mainItem {
            display: none;
            border-radius: 20px;
            padding-left: 20px;
        }
    .mainMenu .mainItem[selected] {
        display: block;
    }
        .mainItem[show]{
            display:block;
        }
    .menuBlock {
        flex-direction: column;
    }
    .subMenu .subChunk {
        width: 100%;
    }
}

@media print {
    .print-invisible {
        display: none;
    }
}